package com.css.simulation.resource.common.infrastructure.mysql.mapper;

import com.css.simulation.resource.common.infrastructure.mysql.entity.AlgorithmExpandInfrastructureEntity;
import com.css.simulation.resource.common.infrastructure.mysql.param.AlgorithmExpandInfrastructureParam;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

@Mapper
public interface AlgorithmExpandMapper {

    @Select(" <script>" +
            " select id, algorithm_id, algorithm_name, description, algorithm_type, status\n" +
            " from algorithm_expand\n" +
            " where 1=1 " +
            " <if test='algorithmIds != null and algorithmIds.size() > 0'>\n" +
            " and algorithm_id in\n" +
            "    <foreach item='item' collection='algorithmIds' separator=',' open='(' close=')'>\n" +
            "      #{item}\n" +
            "    </foreach>" +
            " </if>" +
            " <if test='algorithmId != null and algorithmId != '''>\n" +
            "  and algorithm_id = #{algorithmId}" +
            " </if>" +
            " </script>")
    List<AlgorithmExpandInfrastructureEntity> select(AlgorithmExpandInfrastructureParam algorithmExpandInfrastructureParam);

    @Select(" <script>" +
            " select  algorithm_id\n" +
            " from algorithm_expand\n" +
            " where algorithm_id in\n" +
            "    <foreach item='item' collection='algorithmIds' separator=',' open='(' close=')'>\n" +
            "      #{item}\n" +
            "    </foreach>" +
            "</script>")
    List<String> selectAlgorithmIds(AlgorithmExpandInfrastructureParam algorithmExpandInfrastructureParam);

    @Insert("insert into algorithm_expand(id, algorithm_id, algorithm_name, description, algorithm_type, algorithm_version, team, topic, status)\n\n" +
            "    value (#{id}, #{algorithmId}, #{algorithmName}, #{description}, #{algorithmType},#{algorithmVersion},#{team},{topic}, #{status})\n")
    void insert(AlgorithmExpandInfrastructureEntity algorithmExpandInfrastructureEntity);

    @Update("update algorithm_expand\n" +
            "set id = #{id},\n" +
            "            algorithm_id = #{algorithmId},\n" +
            "            algorithm_name = #{algorithmName},\n" +
            "            description = #{description},\n" +
            "            algorithm_type = #{algorithmType},\n" +
            "            algorithm_version = #{algorithmVersion},\n" +
            "            team = #{team},\n" +
            "            topic = #{topic},\n" +
            "            status = #{status}\n" +
            "where algorithm_id = #{algorithmId}\n")
    void update(AlgorithmExpandInfrastructureEntity algorithmExpandInfrastructureEntity);
}
